Description

Hi, 

with latest version of QGIS master (1.9.90.56) when I load a postGIS view select the primary key column from combobox is mandatory,

whereas with previous version (surely back from 1.9.90.23), if a valid primary exists it was automatically recognized.

Associated revisions

Revision 8eb323af - 2012-06-18 10:20 PM - Jürgen Fischer

fix #4969

History

#1 - 2012-02-08 07:46 AM - Luca Lanteri

A possible solution may be to select the first integer valid primary key. User can also select a different field using the combobox.

#2 - 2012-02-08 08:01 AM - Jürgen Fischer

- Status changed from Open to Feedback

mescal72 - wrote:

A possible solution may be to select the first integer valid primary key. User can also select a different field using the combobox.

The primary key detection wasn't really reliable before.  Being a primary key in the underlying table doesn't necessarily make the columns values unique in

the view - and detecting which of the integer columns are unique can be quite expensive.

What's the problem with having the user select the primary key?

#3 - 2012-02-08 08:40 AM - Giuseppe Sucameli

Jürgen Fischer wrote:

What's the problem with having the user select the primary key?
It could be quite annoying...

Why do not pre-select the combo with the first suitable field returned by the view?

So users can define what field use as default pk for views just changing the view definition.

#4 - 2012-02-08 08:44 AM - Giuseppe Sucameli

Furthermore in this moment the user cannot run the query builder before he defines what's the primary key to use for the view (because the view cannot be

selected if no primary key is set).

#5 - 2012-02-08 10:35 AM - Alessandro Ciali

I don't know if it is pertaining to this issue, but from version 1.9.90.23 the OID is no more recognised as primary key for the view. Is is a bug or a wanted

change?

#6 - 2012-02-08 12:52 PM - Jürgen Fischer

- Resolution set to fixed

- Status changed from Feedback to Closed

fixed in commit:d2b5ed92

#7 - 2012-05-11 05:28 AM - Giuseppe Sucameli

- Resolution deleted (fixed)

- Status changed from Closed to Open

The problem occurs again (regression?). 

The first primary key for views is not pre-selected, on Ubuntu 11.04 and QGis 1.8 d1cb3f3fa.

#8 - 2012-05-11 05:31 AM - Giuseppe Sucameli

- Priority changed from Normal to Severe/Regression

Blocker as policy for regressions.

#9 - 2012-05-14 04:52 PM - Giuseppe Sucameli

The behavior was changed in commit:494561167 probably because if the the first suitable pkey is pre-selected the user doesn't notice the view has more

pkeys.

Even though the user doesn't select any pkey from the dropdown list a view with more suitable pkeys should be selectable. 

If the user loads that view w/o selecting the pkey, QGis should just use the first one in the list.

#10 - 2012-05-17 12:51 PM - Jürgen Fischer

- Crashes QGIS or corrupts data set to No
- Tracker changed from Feature request to Bug report

- Status changed from Open to Closed

- Assignee set to Jürgen Fischer

- Priority changed from Severe/Regression to Normal

- Resolution set to fixed

- Affected QGIS version set to master

Giuseppe Sucameli wrote:

The problem occurs again (regression?). 

The first primary key for views is not pre-selected, on Ubuntu 11.04 and QGis 1.8 d1cb3f3fa.

The mandatory selection of a primary key is intentional.  QGIS just lists all integer fields without caring if they are derived from some primary key or

uniquely indexed table field anymore - because that doesn't tell you anything about their uniqueness in the view anyway.  The user needs to decide - QGIS

will just verify that the selected key is unique (unless "use estimated table metadata" is used).

The valid bug was that oid wasn't considered anymore - and that was fixed.

1.7 projects already have a key field for views in their datasource uri and continue to work - so I don't consider this a regression.

#11 - 2012-06-17 01:59 PM - Luca Lanteri

Ok, but the result is that now I must do a lot of clicks to load multiple views 'cause I have to select all single gid for every view. This is formally correct but

from the user's point of view is a very annoying regression.

I really don't understand why is impossible to have the fist gid candidate as default value in the combobox. If this column is not unique a message box can

prompt the user and the right column can be selected, but if the view is well structured I can save a lot of time.

It's just a piece of advice from an user.

#12 - 2012-06-17 02:23 PM - Jürgen Fischer

- Resolution deleted (fixed)

- Status changed from Closed to Reopened

#13 - 2012-06-18 01:20 PM - Jürgen Fischer

- Status changed from Reopened to Closed

Fixed in changeset commit:"8eb323af13c0d949e6711eac04f553ba2e0848a8".
